### Function

# EDataServer OAuth2Service util_extract_from_uri

since: 3.48

#### Declaration [src]

    gboolean
    e_oauth2_service_util_extract_from_uri (
      const gchar* in_uri,
      gchar** out_authorization_code,
      gchar** out_error_code,
      gchar** out_error_description
    )

#### Description [src]

Extracts either an authorization code from a ‘code’ argument of the `in_uri`, or an error code from an ‘error’ argument of the `in_uri` and an error description from the ‘error_description’ argument of the `in_uri`.

Available since: 3.48

#### Parameters

`in_uri`

  Type: `const gchar*`

  A URI returned from the server.

  The data is owned by the caller of the function.
  The value is a NUL terminated UTF-8 string.

`out_authorization_code`

  Type: `gchar**`

  Extracted authorization code, can be `NULL`.

  The argument will be set by the function.
  The argument can be set to `NULL` by the function.
  The argument can be `NULL`.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.
  The value is a NUL terminated UTF-8 string.

`out_error_code`

  Type: `gchar**`

  Extracted error code, can be `NULL`.

  The argument will be set by the function.
  The argument can be set to `NULL` by the function.
  The argument can be `NULL`.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.
  The value is a NUL terminated UTF-8 string.

`out_error_description`

  Type: `gchar**`

  Extracted error description, can be `NULL`.

  The argument will be set by the function.
  The argument can be set to `NULL` by the function.
  The argument can be `NULL`.
  The caller of the function takes ownership of the returned data, and is responsible for freeing it.
  The value is a NUL terminated UTF-8 string.

#### Return value

Type: `gboolean`

`TRUE`, when any of the non-NULL out arguments had been populated.